searchNodes=[{"doc":"A generic behaviour for implementing Splunk clients for OffBroadway.Splunk.Producer . This module defines callbacks to normalize options and receive items for a Splunk SID (Search ID). Modules that implements this behaviour should be passed as the :splunk_client option from OffBroadway.Splunk.Producer .","ref":"OffBroadway.Splunk.Client.html","title":"OffBroadway.Splunk.Client","type":"behaviour"},{"doc":"","ref":"OffBroadway.Splunk.Client.html#c:ack_message/2","title":"OffBroadway.Splunk.Client.ack_message/2","type":"callback"},{"doc":"","ref":"OffBroadway.Splunk.Client.html#c:init/1","title":"OffBroadway.Splunk.Client.init/1","type":"callback"},{"doc":"","ref":"OffBroadway.Splunk.Client.html#c:receive_messages/3","title":"OffBroadway.Splunk.Client.receive_messages/3","type":"callback"},{"doc":"","ref":"OffBroadway.Splunk.Client.html#c:receive_status/2","title":"OffBroadway.Splunk.Client.receive_status/2","type":"callback"},{"doc":"","ref":"OffBroadway.Splunk.Client.html#t:messages/0","title":"OffBroadway.Splunk.Client.messages/0","type":"type"},{"doc":"The OffBroadway.Splunk.Leader module is responsible to poll Splunk for status on a SID and notify the OffBroadway.Splunk.Producer when Splunk is ready to deliver messages for given SID.","ref":"OffBroadway.Splunk.Leader.html","title":"OffBroadway.Splunk.Leader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"OffBroadway.Splunk.Leader.html#child_spec/1","title":"OffBroadway.Splunk.Leader.child_spec/1","type":"function"},{"doc":"","ref":"OffBroadway.Splunk.Leader.html#start_link/1","title":"OffBroadway.Splunk.Leader.start_link/1","type":"function"},{"doc":"","ref":"OffBroadway.Splunk.Leader.State.html","title":"OffBroadway.Splunk.Leader.State","type":"module"},{"doc":"","ref":"OffBroadway.Splunk.Leader.State.html#new/2","title":"OffBroadway.Splunk.Leader.State.new/2","type":"function"},{"doc":"","ref":"OffBroadway.Splunk.Leader.State.html#t:t/0","title":"OffBroadway.Splunk.Leader.State.t/0","type":"type"},{"doc":"OffBroadway Splunk option definitions and custom validators.","ref":"OffBroadway.Splunk.Options.html","title":"OffBroadway.Splunk.Options","type":"module"},{"doc":"","ref":"OffBroadway.Splunk.Options.html#definition/0","title":"OffBroadway.Splunk.Options.definition/0","type":"function"},{"doc":"","ref":"OffBroadway.Splunk.Options.html#type_nil_or_pos_integer/2","title":"OffBroadway.Splunk.Options.type_nil_or_pos_integer/2","type":"function"},{"doc":"","ref":"OffBroadway.Splunk.Options.html#type_non_empty_string/2","title":"OffBroadway.Splunk.Options.type_non_empty_string/2","type":"function"},{"doc":"GenStage Producer for a Splunk Event Stream. Broadway producer acts as a consumer for the specified Splunk SID. Producer Options :sid - Required. The SID (Search ID) for the Splunk job we want to consume events from. :receive_interval - The duration (in milliseconds) for which the producer waits before making a request for more messages. The default value is 5000 . :shutdown_timeout - The duration (in milliseconds) Broadway should wait before timing out when trying to stop the pipeline. The default value is :infinity . :on_success - Configures the acking behaviour for successful messages. See the &quot;Acknowledgements&quot; section below for all the possible values. The default value is :ack . :on_failure - Configures the acking behaviour for failed messages. See the &quot;Acknowledgements&quot; section below for all the possible values. The default value is :noop . :splunk_client - A module that implements the OffBroadway.Splunk.Client behaviour. This module is responsible for fetching and acknowledging the messages from Splunk. All options passed to the producer will also be forwarded to the client. The default value is OffBroadway.Splunk.SplunkClient . :config - A set of config options that overrides the default config for the splunk_client module. Any option set here can also be configured in config.exs . The default value is [] . :base_url - Base URL to Splunk instance. :api_token - API token used to authenticate on the Splunk instance. :endpoint - Configures if output should be consumed from the events or results endpoint of the Splunk API. In Splunk terminology, results are the output after transformation commands has been executed. Consider the following search command: * | head 1000 | stats count by sourcetype The output from the command above is no longer the raw events because they have been transformed by the search command. Splunk call these transformed events results . To receive the computed values, you should choose to use the results endpoint. If you want to receive all events that produced this output, choose the events endpoint. The default value is :events . :offset - Initial offset can be used to skip N before starting to consume messages. If using events endpoint, a negative value can be used to start consuming &quot;from the end&quot;, where -1 is the last available offset. The default value is 0 . :max_events - If set to a positive integer, automatically shut down the pipeline after consuming max_events messages from the Splunk API. Acknowledgements You can use the on_success and on_failure options to control how messages are acknowledged. You can set these options when starting the Splunk producer or change them for each message through Broadway.Message.configure_ack/2 . By default, successful messages are acked ( :ack ) and failed messages are not ( :noop ). The possible values for :on_success and :on_failure are: :ack - acknowledge the message. Splunk does not have any concept of acking messages, because we are just consuming messages from a web api endpoint. For now we are just executing a :telemetry event for acked messages. :noop - do not acknowledge the message. No action are taken. Telemetry This library exposes the following telemetry events: [:off_broadway_splunk, :job_status, :start] - Dispatched before polling SID status from Splunk. measurement: %{time: System.monotonic_time} metadata: %{sid: string, progress: integer} [:off_broadway_splunk, :job_status, :stop] - Dispatched when polling SID status from Splunk is complete. measurement: %{time: native_time} metadata: %{sid: string, progress: integer} [:off_broadway_splunk, :job_status, :exception] - Dispatched after a failure while polling SID status from Splunk. measurement: %{duration: native_time} metadata: %{ sid : string , kind : kind , reason : reason , stacktrace : stacktrace } [:off_broadway_splunk, :receive_messages, :start] - Dispatched before receiving messages from Splunk ( c:receive_messages/2 ) measurement: %{time: System.monotonic_time} metadata: %{sid: string, demand: integer} [:off_broadway_splunk, :receive_messages, :stop] - Dispatched after messages have been received from Splunk and &quot;wrapped&quot;. measurement: %{time: native_time} metadata: %{ sid : string , received : integer , demand : integer } [:off_broadway_splunk, :receive_messages, :exception] - Dispatched after a failure while receiving messages from Splunk. measurement: %{duration: native_time} metadata: %{ sid : string , demand : integer , kind : kind , reason : reason , stacktrace : stacktrace } [:off_broadway_splunk, :receive_messages, :ack] - Dispatched when acking a message. measurement: %{time: System.system_time, count: 1} meatadata: %{ sid : string , receipt : receipt }","ref":"OffBroadway.Splunk.Producer.html","title":"OffBroadway.Splunk.Producer","type":"module"},{"doc":"Default Splunk client used by OffBroadway.Splunk.Producer to receive data from Splunk. This module implements the OffBroadway.Splunk.Client and Broadway.Acknowledger behaviours which define callbacks for receiving and acknowledging events. Since Splunk does not have any concept of acknowledging consumed events, we need to keep track of what events that are consumed ourselves (more on that later). The default Splunk client uses the Splunk Web API for receiving events and is implemented using the Tesla library. Tesla is a HTTP client abstraction library which let's us easily select from a range of HTTP adapters. Please see the Tesla documentation for more information.","ref":"OffBroadway.Splunk.SplunkClient.html","title":"OffBroadway.Splunk.SplunkClient","type":"module"},{"doc":"Returns a Tesla.Client configured with middleware. Tesla.Middleware.BaseUrl middleware configured with base_url passed via opts . Tesla.Middleware.BearerAuth middleware configured with api_token passed via opts . Tesla.Middleware.Query middleware configured with query passed via opts . Tesla.Middleware.JSON middleware configured with Jason engine.","ref":"OffBroadway.Splunk.SplunkClient.html#client/1","title":"OffBroadway.Splunk.SplunkClient.client/1","type":"function"},{"doc":"A Splunk event consumer for Broadway . Broadway producer acts as a consumer for the given Splunk SID (Search ID). Splunk does not really provide a queue we can consume events from, so we need to fetch events using the Splunk Web API. When the Broadway pipeline starts, it will also start a OffBroadway.Splunk.Leader process which will poll Splunk for job status of the given SID . Once Splunk reports that the job is ready to be consumed the OffBroadway.Splunk.Producer will start fetching events and passing them through the Broadway system. Read the full documentation here .","ref":"readme.html","title":"OffBroadway.Splunk","type":"extras"},{"doc":"This package is available in Hex , and can be installed by adding off_broadway_splunk to your list of dependencies in mix.exs : def deps do [ { :off_broadway_splunk , &quot;~&gt; 1.1&quot; } ] end","ref":"readme.html#installation","title":"OffBroadway.Splunk - Installation","type":"extras"},{"doc":"The OffBroadway.Splunk.SplunkClient tries to read the following configuration from config.exs . # config.exs config :off_broadway_splunk , :splunk_client , base_url : System . get_env ( &quot;SPLUNK_BASE_URL&quot; , &quot;https://splunk.example.com&quot; ) , api_token : System . get_env ( &quot;SPLUNK_API_TOKEN&quot; , &quot;your-api-token-here&quot; ) Options for the OffBroadway.Splunk.SplunkClient can be configured either in config.exs or passed as options directly to the OffBroadway.Splunk.Producer module. Options are merged, with the passed options taking precedence over those configured in config.exs . # my_broadway.ex defmodule MyBroadway do use Broadway alias Broadway.Message def start_link ( _opts ) do Broadway . start_link ( __MODULE__ , name : __MODULE__ , producer : [ module : { OffBroadway.Splunk.Producer , sid : &quot;SID-to-consume&quot; , config : [ api_token : &quot;override-api-token&quot; ] } ] , processors : [ default : [ ] ] , batchers : [ default : [ batch_size : 500 , batch_timeout : 5000 ] ] ) end ... callbacks ... end Processing messages In order to process incoming messages, we need to implement some callback functions. defmodule MyBroadway do use Broadway alias Broadway.Message ... start_link ... @impl true def handle_message ( _ , % Message { data : data } , _ ) do message |&gt; Message . update_data ( fn -&gt; ... whatever ... end ) end @impl true def handle_batch ( _batcher , messages , _batch_info , _context ) do IO . puts ( &quot;Received a batch of \#{ length ( messages ) } messages!&quot; ) messages end end For the sake of the example, we're not really doing anything here. Whenever we're receiving a batch of messages, we just prints out a message saying &quot;Received a batch of messages!&quot;, and for each message we run Message.update_data/2 passing a function that can process that message ie. by doing some calculations on the data or something else.","ref":"readme.html#usage","title":"OffBroadway.Splunk - Usage","type":"extras"},{"doc":"Copyright 2022 Intility Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]